<?php
/**
 * plugin_catalogue_marcxml_wizard_emplacement()
 * 
 * Ce plugin va retourner un choix dans un arbre  partir d'un certain nombre de critres
 * Il peut tre utilise (par exemple) pour dterminer le code emplacement  partir de la cote, du type doc et d'autres paramtres
 * 
 * [infos] => les critres qui seront utiliss pour dterminer quel code retourner. par exemple, si se base sur le type doc et la cote on pourra avoir :
 *            [0] => LIV , [1] => SF TOT
 * [choix] => l'arbre des choix possibles en fonction des critres ci dessus. A chaque niveau, un noeud [_else] indiquera le coix par dfaut
 *            par exemple :
 *              [LIV]
 *                    [0]=>gnralits
 *                    [1]=>philosophie
 *                    [_else]=>indtermin
 *               [_else]
 *                    [R]=> fiction
 * 
 * NOTE : le teste se fait systmatiquement avec trocature  droite (par ex. SF TOTO correspondra bien  SF)
 * 
 * NOTE2 : l'arbre est invers de telle sorte que les codes les plus prcis seront tests avant les plus gnraux. Ainsi 91 sera test avant 9
 * 
 * retourne [code]
 * 
 * @param mixed $parametres
 * @return
 */
function plugin_catalogue_marcxml_wizard_emplacement ($parametres) {
    $retour=array();
    $retour["succes"]=1;
    $retour["resultat"]=array();
    
    $infos=$parametres["infos"]; // les critres pertinents par exemple [0]=>LIV, [1]=>SF TOT
    $choix=$parametres["choix"]; // l'arbre de dcision
    
    $pointeur=$choix;
    foreach($infos as $idx_info => $info) {
        $pointeur=plugin_catalogue_marcxml_wizard_emplacement_teste_pointeur($info, $pointeur);
        if ($pointeur=="") {
            return($retour);
        }
    }
    if (!is_string($pointeur)) {
        return($retour);
    }
    $retour["resultat"]["code"]=$pointeur;
    
    
    return($retour);   
}

function plugin_catalogue_marcxml_wizard_emplacement_teste_pointeur ($critere, $choix) {
    $choix=array_reverse($choix, true);
    settype($critere, "string");
    foreach ($choix as $choi => $tableau) { // ^^ 
    settype($choi, "string");

    $toto=stripos($critere, $choi);
        if ($toto === 0) {
            return($tableau);
        }
    }
    if (isset($choix["_else"])) {
        return ($choix["_else"]);
    } 
    return ("");
}



?>