<?php
/**
 * plugin_div_get_cab_incrementiel()
 * 
 * Ce plugin retourne le n incrmentiel suivant pour un type de cab et met  jour le compteur associ
 * 
 * @param mixed $parametres
 * @param [longueur] => la longueur du cab  gnrer (y compris le prfixe)
 * @param [prefixe] => prfixe du cab  gnrer
 * @param [chemin_compteur] => chemin du compteur dans le registre o est indiqu le dernier numro  partir de system/compteurs/... : SANS le prfixe. peut tre le nom du compteur ou prcd d'un chemin (sans commencer par slash)
 * 
 * @return [cab] => le cb gnr
 * 
 */
function plugin_div_get_cab_incrementiel ($parametres) {
    $retour=array();
    $retour["succes"]=1;
    $retour["resultat"]=array();
    $retour["resultat"]["cab"]="";
    
    $longueur=$parametres["longueur"];
    $prefixe=$parametres["prefixe"];
    $chemin_compteur=$parametres["chemin_compteur"];
    
    // on rcupre le n incrmentiel
    $incrementiel=get_compteur($chemin_compteur);
    if ($incrementiel===false) {
        $tmp["succes"]=0;
        $tmp["erreur"]="Le compteur system/compteur/$chemin_compteur n'existe pas";
        return ($tmp);
    }
    
    // on calcule longueur incrmentiel
    $longueur_incrementiel=$longueur;
    if ($prefixe!="") {
        $longueur_prefixe=strlen($prefixe);
        $longueur_incrementiel-=$longueur_prefixe;
    }
    
    // on rajoute autant de "0" que ncessaire avant incrementiel pour avoir la bonne longueur
    $suffixe=str_pad($incrementiel,$longueur_incrementiel, "0", STR_PAD_LEFT);
    
    // on colle le prfixe et le suffixe
    $retour["resultat"]["cab"]=$prefixe.$suffixe;
    
    return ($retour);
}



?>