<?php

/**
 * plugin_div_util_str_choix()
 * 
 * Ce plugin retourne une chaine [texte] en fonction d'une chaine entre [texte]. Les diffrentes valeurs possibles sont paramtres dans [liste]
 * on peut mettre [liste][_else] qui sera une valeur par dfaut
 * 
 * NOTE : mme si ce plugin est prvu  la base pour retourner du texte, il peut trs bien retourner en fait une array (dans le registre)
 * 
 * @param mixed $parametres
 * @param [texte] => la valeur  tester
 * @param [liste][xxx|yyy|_else] => les diffrentes valeurs possibles de [texte] et la valeur de remplacement
 *                                  Si vaut [_else] => valeur par defaut
 * @param on peut galement mettre une clef [_void] qui sera appele si [texte] == ""
 * 
 * @return [texte]
 */
function plugin_div_util_str_choix ($parametres) {
    $retour=array();
    $retour["succes"]=1;
    $retour["resultat"]=array();
    
    $texte=$parametres["texte"];
    $liste=$parametres["liste"];
    $else=$liste["_else"];
    if ($texte == "") {
        $texte="_void";
    }
    
    if (isset($liste[$texte])) {
        $retour["resultat"]["texte"]=$liste[$texte];
    } else {
        $retour["resultat"]["texte"]=$else;
    }
    
    return ($retour);
}

?>